/* checkvis.c  mtb version  14.9.02 
  Run this if ch3.c works OK
*/

#include <time.h>
#include <stdio.h>
#include <math.h>
#include <X11/Xlib.h>
#include <X11/Xutil.h>


unsigned long black, white, red, green, blue, magenta;

main(argc, argv)

     int argc;
     char *argv[];

{     /*main*/
  Display *display;
  Display *ConnectToServer();
  Window  rootwindow,window;
  Window OpenWindow();
  int screen;
  int x,y,width,height;
  Visual *visual=CopyFromParent;
  GC  gc;
  GC  CreateGC();
  XEvent event;
  int count,depth,status;
  Colormap colormap;
  unsigned long AllocNamedColor();
  XSetWindowAttributes attributes;

  unsigned long ma,mb,mc,m1,m2,m3,m4;
  int vis_id,vis_cl, nclose;
  float ua,ub,uc,u1,u2,u3,u4;
  long time1,t2;

  display= ConnectToServer( (char *) NULL, &screen, &rootwindow);

  /*  printf("About to probe default visual \n");*/

  CheckVisual(display, screen, &visual,&depth);

  x=10;y=30;width=300;height=300;

  printf("\n About to call OpenWindow \n");
  window=OpenWindow( display, rootwindow, x,y,width,height,
 	            BlackPixel(display,screen),
	            WhitePixel(display,screen),
                    ExposureMask, visual);

  /*  SetStandardHints(display,window,argv[0],argv[0],x,y,width,height);*/
 
  printf("About to call CreateGC \n");
 
  gc=CreateGC(display, window, 
	   BlackPixel(display,screen),
	   WhitePixel(display,screen));

       printf("About to call XMapRaised \n");
  
  XMapRaised(display,window);
  XFlush(display);

  printf("A blank window should have appeared. Press key to continue \n");
  scanf("%d", &nclose);
  printf("About to start writing to window, which will remain for 6 seconds \n");
 
  ma=20000;
  ma=visual->red_mask;mb=visual->green_mask;mc=visual->blue_mask;
  time1=clock();t2=0;

  while(t2<time1+60000){ t2=clock();
  XSetForeground(display,gc,ma);
  XFillRectangle(display,window,gc,0,0,100,100);
  XSetForeground(display,gc,mb);
  XFillRectangle(display,window,gc,100,100,100,100);
  XSetForeground(display,gc,mc);
  XFillRectangle(display,window,gc,200,200,100,100);
  }

  XCloseDisplay(display);  
}

Display *ConnectToServer( display_name, screen, rootwindow)

     char display_name[];
     int *screen;
     Window *rootwindow;

{
  Display *display;

  display= XOpenDisplay(display_name);

  if( display== (Display *) NULL)
    { printf("error in connect to server \n");     exit(1);    }

  *screen = DefaultScreen (display);
  *rootwindow= RootWindow(display,*screen);
  return(display);
} 

  Window  OpenWindow( display, parent, x,y,width,height,
            bordercolor, backcolor, event_mask, visual)

  Display *display;
  Window parent;
  int x,y,width,height;
  unsigned long bordercolor, backcolor;
  unsigned long event_mask;
  Visual *visual;

{ 
  Window window;
  XSetWindowAttributes attributes;
  unsigned long  attr_mask;

  attributes.event_mask=event_mask;
  attributes.border_pixel= bordercolor;
  attributes.background_pixel= backcolor;
  attr_mask= CWEventMask | CWBackPixel | CWBorderPixel;

  window=XCreateWindow(display,parent,x,y,width,height,
		       2,
                       CopyFromParent,
                       InputOutput,
                       visual,attr_mask, &attributes); 
   
  return(window);
}

GC CreateGC(display,drawable,forecolor,backcolor)

  Display *display;
  Drawable drawable;
  unsigned long forecolor,backcolor;
{ 
  XGCValues xgcvalues;
   GC gc;
   xgcvalues.foreground=forecolor;
   xgcvalues.background=backcolor;

   gc=XCreateGC(display,drawable,
		(GCForeground|GCBackground), &xgcvalues);

   return gc;
}

/*CheckVisual.  Examines visual array
mtb version 7.9.02  */
 
CheckVisual(display, screen, visual,depth)

 Display *display;
 int screen;
 Visual **visual;
 int *depth;

{
  int no_vis,vis_id,vis_cl,rm,gm,bm,bits,mape;
  XVisualInfo *visual_array;
  XVisualInfo visual_info_template;
  Visual *def_vis;
  int status=False;
  int vclass=0;

  printf("Entered CheckVisual\n");

   *depth=DefaultDepth(display,screen);
   *visual=DefaultVisual(display,screen); 
  
   printf("Default screen %d,  depth %u  \n",screen, *depth);
   printf("Default *visual = %u, visual = %u \n",*visual,visual);

   def_vis=DefaultVisual(display,screen);

   vis_cl=def_vis->class;
   printf("Original visual class %x  \n",vis_cl);  
   vis_id=def_vis->visualid; 
   printf("Original visual id %x  \n",vis_id);
   rm=def_vis->red_mask;
   gm=def_vis->green_mask;
   bm=def_vis->blue_mask;
   bits=def_vis->bits_per_rgb;
   mape=def_vis->map_entries;
   printf("Colour Masks %x %x %x  \n", rm,gm,bm);
   printf("Bits per rgb %d  map entries %d \n",bits,mape);

   if (DefaultVisual(display,screen)->class == TrueColor){
    vclass=0;}
  else {vclass=1;}

  if(vclass==0){
    printf("True Color is default \n"); }

  if(vclass !=0){
       printf("True Color is NOT default \n");}

    printf("Now searching for other visuals ... \n");

    visual_info_template.class=TrueColor;
    visual_info_template.screen=screen;

    visual_array=XGetVisualInfo(display,
	VisualClassMask|VisualScreenMask,&visual_info_template,&no_vis);

    printf("Number of TrueColor visuals found is %d  \n",no_vis);
    printf("Settings for first TrueColor found\n");

    *visual=visual_array[0].visual;
    vis_id=visual_array[0].visualid;
    vis_cl=visual_array[0].class;
    *depth=visual_array[0].depth;
    XFree(visual_array);

   printf("Screen %d Depth %u  ",screen, *depth);
   printf(" id %x  ",vis_id);
   printf(" class %x  \n",vis_cl);

   printf("CheckVisual about to return \n"); 

}

